//+------------------------------------------------------------------+
//|                                          TestCallByReference.mq5 |
//|                                                  Adylbek Akmatov |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Adylbek Akmatov"
#property link      ""
#property version   "1.00"

class A {
    datetime time;

public:
    A( const datetime &_time ) {
        this.time = _time;
    }

    string toString() {
        return StringFormat( "Time = %s", TimeToString( time, TIME_DATE | TIME_MINUTES ) );
    }
};

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
//---
    datetime _time = TimeCurrent();
    A *a = new A( _time );
    
    process( a );
    Print( a.toString() );
    
    delete( a );     
}

void process( A &_a ) {
    Print( _a.toString() );
}
//+------------------------------------------------------------------+
